package com.aza.vp.game;


public class DeucesWild  extends Poker
{
    public DeucesWild(int type) {
		super(type);
	}


	public static final int NUM_CARDS = 52;
    
    
    public static final int MIN_HIGH_PAYD = 0;
    

    public static final int NATURAL_ROYAL_FLUSH = 0;
    public static final int FOUR_DEUCES = 1;
    public static final int WILD_ROYAL_FLUSH = 2;
    public static final int FIVE_OF_A_KIND = 3;
    public static final int STRAIGHT_FLUSH = 4;
    public static final int FOUR_OF_A_KIND = 5;
    public static final int FULL_HOUSE = 6;
    public static final int FLUSH = 7;
    public static final int STRAIGHT = 8;
    public static final int THREE_OF_KIND = 9;
    
    // for hold only, pays nothing
    public static final int TWO_PAIRS = 10;
    public static final int PAIR = 11;

    public static final int payout[] =
        {
                800,
                200,
                25,
                15,
                9,
                5,
                3,
                2,
                2,
                1
        };

  	String hand_cat[] =
        {
                "NATURAL ROYAL FLUSH",
                "FOUR DEUCES",
                "WILD_ROYAL FLUSH",
                "FIVE OF A KIND",
                "STRAIGHT FLUSH",
                "FOUR OF A KIND",
                "FULL HOUSE",
                "FLUSH",
                "STRAIGHT",
                "THREE OF A KIND"
        };

    
    @Override
	public int[] getPayoutTable()
    {
		return payout;
	}


	@Override
	public String[] getHandCat()
	{
		return hand_cat;
	}


	@Override
	public int getPayout(int hand)
	{
		return payout[hand];
	}


	@Override
	public String getHandString(int res)
	{
		return hand_cat[res];
	}
	

	@Override
	public int getNumCards()
	{
		// TODO Auto-generated method stub
		return NUM_CARDS;
	}
	
	@Override
    public int checkHand(int hold[], int n_wild)
    {    	
		return checkHand_static(hold, n_wild);
    }
	
	    
    public static int checkHand_static(int hold[], int n_wild)
    {
    	int res = NOTHING;
    	
    	int rank_test[] = new int[13];
    	 		
    	boolean posible_straight = true;
    	boolean three = false;
    	int two = 0;
    	
    	int min = Integer.MAX_VALUE;
  		int max = Integer.MIN_VALUE;
    	
        int min_rank = Integer.MAX_VALUE;
 		int max_rank = Integer.MIN_VALUE;
 		int max_rank_up_to_K = Integer.MIN_VALUE;
 		for (int i = 0; i < hold.length; i++)
 		{
 			int rank = hold[i] % 13;
 			
 			if (rank == 0) continue; // 0 deuces wild
 			
 			rank_test[rank]++; 			
 			int cnt = rank_test[rank];
    		
    		if (cnt + n_wild == 4) res = FOUR_OF_A_KIND;
	 		if (cnt + n_wild == 5) res = FIVE_OF_A_KIND;
	 		
	 		if (cnt == 3) three = true;
	 		if (cnt == 2) two++;
 			
 			if (rank_test[rank] > 1) posible_straight = false; // same rank, except deuces - no straight posible
 			
 			if (min > hold[i]) min = hold[i];
 			if (max < hold[i]) max = hold[i];
 			
 			if (min_rank > rank) min_rank = rank;
 			if (max_rank < rank) max_rank = rank;
 			
 			if (max_rank_up_to_K < rank && rank < 12) // up to K
            	 max_rank_up_to_K = rank;
 		}
 		
 		boolean flush = false;
 		boolean straight = false;
 		
 		if (posible_straight) 
        {        	 
        	 if ((max_rank) - (min_rank) < 5)
        	 {
        		 straight = true;
        		 if (res > STRAIGHT) res = STRAIGHT;
        	 }
         	 else if (max_rank == 12) // ace
         	 {
         		 if ((max_rank_up_to_K) < 4) // A2345
         		 {         			 
         			straight = true;
         			if (res > STRAIGHT) res = STRAIGHT;
            	 }
         	 }
        }
 		
 		if ((min / 13 == max / 13) && (max - min < 13))
 		{
 			flush = true;
 			if (res > FLUSH) res = FLUSH;
 		}
        
        if (flush && straight)
        {
        	res = STRAIGHT_FLUSH;
        	
        	if (min_rank >= 8 && max_rank <= 12)
        	{
        		if (n_wild == 0)
        		{
        			res = NATURAL_ROYAL_FLUSH;
        		}
        		else if (n_wild < 4)
        		{
        			res = WILD_ROYAL_FLUSH;
        		}
        	}
        }
    	
    	boolean fh = false;
    	if (n_wild == 0) // 3168
    	{
    		if (three && two == 2)
    			fh = true;
    	}
    	else if (n_wild == 1) // 9,504
    	{
    		if (three) fh = true;    		
    		else if ( two == 2) fh = true;
    	}
    	// 12,672
    	
    	if (res > FULL_HOUSE)
    	{
    		if (fh)
        	{
        		res = FULL_HOUSE;
        	}
    	}
    	
    	if (res > THREE_OF_KIND)
    	{
    		if (three && n_wild == 0) // ok - 42,240
        	{
        		res = THREE_OF_KIND;
        	}
        	
    		if (n_wild == 1 && two == 1) // OK - 253440
    			res = THREE_OF_KIND;
        	
        	if (n_wild == 2) // ok - 59,400
        	{
        		res = THREE_OF_KIND;
        	}
    	}
    	
    	if (res != NATURAL_ROYAL_FLUSH && n_wild == 4) res = FOUR_DEUCES;
        
        return res;
    }	
	
	
	public int hold[];
	
	 @Override
	 public int[] getHold()
	 {
	      return hold;
	 }
	 
	 public void getHold(int hand[], int res, int card, int d1, int d2)
	    {
	        hold = new int[5];


	        if (res == NATURAL_ROYAL_FLUSH || res == WILD_ROYAL_FLUSH || res == STRAIGHT || res == FLUSH || res == FULL_HOUSE || res == STRAIGHT_FLUSH || res == FIVE_OF_A_KIND)
	        {
	            holdAll(hold);
	        } 
	        else if (res == FOUR_OF_A_KIND || res == THREE_OF_KIND)
	        {
	            holdCard(hand, card, hold);
	            holdCard(hand, d1, hold);
	        }
	        else if (res == TWO_PAIRS)
	        {
	            holdCard(hand, d1, hold);
	            holdCard(hand, d2, hold);
	        }
	        else //if (res == HIGH_PAIR)
	        {
	            if (d1 > MIN_HIGH_PAYD)
	                holdCard(hand, d1, hold);
	            //else
	              //  holdHighCard(hand, hold);

	        }

	        holdJokers(hand, hold);
	    }

	 public void holdJokers(int hand[], int hold[])
	    {
	        for (int i = 0; i < hold.length; i++)
	        {
	            if (hand[i] % 13 == 0)
	                hold[i] = 1;
	        }
	    }

	@Override
	public int getWildCardRank()
	{
		return 0; // 0 deuces
	}


	


	

	
}
