package com.aza.vp.game;

public class JacksOrBetter extends Poker
{
    public JacksOrBetter(int type) {
		super(type);
	}


	@Override
    public int[] getHold()
    {
        return null;
    }

    public static final int NUM_CARDS = 52;

    public static final int ROYAL_FLUSH = 0;
    public static final int STRAIGHT_FLUSH = 1;
    public static final int FOUR_OF_A_KIND = 2;
    public static final int FULL_HOUSE = 3;
    public static final int FLUSH = 4;
    public static final int STRAIGHT = 5;
    public static final int THREE_OF_KIND = 6;
    public static final int TWO_PAIRS = 7;
    public static final int HIGH_PAIR = 8;
    
	int payout[] =
        {
                800,
                50,
                25,
                9,
                6,
                4,
                3,
                2,
                1
        };
	
	String hand_cat[] =
        {
                "ROYAL_FLUSH",
                "STRAIGHT_FLUSH",
                "FOUR_OF_KIND",
                "FULL_HOUSE",
                "FLUSH",
                "STRAIGHT",
                "THREE_OF_KIND",
                "TWO_PAIRS",
                "JACKS_OR_BETTER"
        };
    
    
    @Override
   	public int[] getPayoutTable()
       {
   		return payout;
   	}


   	@Override
   	public String[] getHandCat()
   	{
   		return hand_cat;
   	}


   	@Override
   	public int getPayout(int hand)
   	{
   		return payout[hand];
   	}


   	@Override
   	public String getHandString(int res)
   	{
   		return hand_cat[res];
   	}

    public int getNumCards()
    {
        return  NUM_CARDS;
    }
    
    @Override
	public int getWildCardRank()
	{
		return -1;
	}
    


    public void holdJokers(int hand[], int hold[])
    {
        for (int i = 0; i < hold.length; i++)
        {
            if (hand[i] > 51)
                hold[i] = 1;
        }
    }

	@Override
	public int checkHand(int[] hand, int n_wild)
	{
		return checkHand_static(hand, n_wild, 9);
	}
	
	
    public static int checkHand_static(int hold[], int n_wild, int min_pair)
    {
    	int res = NOTHING;
    	
    	int rank_test[] = new int[13];
    	 		
    	boolean posible_straight = true;
    	boolean three = false;
    	int two = 0;
    	
    	int min = Integer.MAX_VALUE;
  		int max = Integer.MIN_VALUE;
    	
  		int pair_rank = -1;
        int min_rank = Integer.MAX_VALUE;
 		int max_rank = Integer.MIN_VALUE;
 		int max_rank_up_to_K = Integer.MIN_VALUE;
 		for (int i = 0; i < hold.length; i++)
 		{
 			int rank = hold[i] % 13;
 			
 			rank_test[rank]++;
 			
 			int cnt = rank_test[rank];
 			
 			//if (rank == wild_rank) continue; // 0 deuces wild, -1 joker poker
    		
    		if (cnt + n_wild == 4) res = FOUR_OF_A_KIND;
	 		
	 		if (cnt == 3) three = true;
	 		if (cnt == 2)
	 		{
	 			pair_rank = rank;
	 			two++;
	 		}
 			
 			if (rank_test[rank] > 1) posible_straight = false; // same rank, except deuces - no straight posible
 			
 			if (min > hold[i]) min = hold[i];
 			if (max < hold[i]) max = hold[i];
 			
 			if (min_rank > rank) min_rank = rank;
 			if (max_rank < rank) max_rank = rank;
 			
 			if (max_rank_up_to_K < rank && rank < 12) // up to K
            	 max_rank_up_to_K = rank;
 		}
 		
 		boolean flush = false;
 		boolean straight = false;
 		
 		if (posible_straight) 
        {        	 
        	 if ((max_rank) - (min_rank) < 5)
        	 {
        		 straight = true;
        		 if (res > STRAIGHT) res = STRAIGHT;
        	 }
         	 else if (max_rank == 12) // ace
         	 {
         		 if ((max_rank_up_to_K) < 4) // A2345
         		 {         			 
         			straight = true;
         			if (res > STRAIGHT) res = STRAIGHT;
            	 }
         	 }
        }
 		
 		if ((min / 13 == max / 13) && (max - min < 13))
 		{
 			flush = true;
 			if (res > FLUSH) res = FLUSH;
 		}
        
        if (flush && straight)
        {
        	res = STRAIGHT_FLUSH;
        	
        	if (min_rank >= 8 && max_rank <= 12)
        	{
        		if (n_wild == 0)
        		{
        			res = ROYAL_FLUSH;
        		}
        	}
        }
    	
    	boolean fh = false;
    	if (n_wild == 0)
    	{
    		if (three && two == 2)
    			fh = true;
    	}
    	else if (n_wild == 1)
    	{
    		if (three) fh = true;    		
    		else if ( two == 2) fh = true;
    	}
    	
    	if (res > FULL_HOUSE)
    	{
    		if (fh)
        	{
        		res = FULL_HOUSE;
        	}
    	}
    	
    	if (res > THREE_OF_KIND)
    	{
    		if (three && n_wild == 0)
        	{
        		res = THREE_OF_KIND;
        	}
        	
    		if (n_wild == 1 && two == 1)
    			res = THREE_OF_KIND;
        	
        	if (n_wild == 2)
        	{
        		res = THREE_OF_KIND;
        	}
    	}
    	
    	if (res > TWO_PAIRS)
    	{
    		if (two == 2) res = TWO_PAIRS;
    		if (two == 1 && pair_rank >= min_pair ) res = HIGH_PAIR; // 9 - Jacks
    	}
        
        return res;
    }
}
