package com.aza.vp.game;

public class TestHand
{
	
	public static int CR_NATURAL_ROYAL_FLUSH = 0;
	public static int CR_FOUR_DEUCES = 1;
	public static int CR_WILD_ROYAL_FLUSH = 2;
	public static int CR_FIVE_OF_A_KIND = 3;
    public static int CR_STRAIGHT_FLUSH = 4;
    public static int CR_FOUR_OF_A_KIND = 5;
    public static int CR_FULL_HOUSE = 6;
    public static int CR_FLUSH = 7;
    public static int CR_STRAIGHT = 8;
    public static int CR_THREE_OF_KIND = 9;
    
    
    static int check_result[] = new int[10];
    
    static void reset_result()
    {
    	check_result[0] = -1;
    	check_result[1] = -1;
    	check_result[2] = -1;
    	check_result[3] = -1;
    	check_result[4] = -1;
    	check_result[5] = -1;
    	check_result[6] = -1;
    	check_result[7] = -1;
    	check_result[8] = -1;
    	check_result[9] = -1;
    }
    
    
    public static int[] check_ALL(int hold[], int n_wild, int wild_rank)
    {    	
    	reset_result();
    	
    	int rank_test[] = new int[13];
    	 		
    	boolean posible_straight = true;
    	boolean three = false;
    	int two = 0;
    	
    	int min = Integer.MAX_VALUE;
  		int max = Integer.MIN_VALUE;
    	
        int min_rank = Integer.MAX_VALUE;
 		int max_rank = Integer.MIN_VALUE;
 		int max_rank_up_to_K = Integer.MIN_VALUE;
 		for (int i = 0; i < hold.length; i++)
 		{
 			int rank = hold[i] % 13;
 			
 			rank_test[rank]++;
 			
 			int cnt = rank_test[rank];
 			
 			if (rank == 0) continue;
 			
// 			if (rank != wild_rank)
// 			{
// 				if (rank_test[rank] + n_wild == 4) check_result[CR_FOUR_OF_A_KIND] = rank;
// 	 			if (rank_test[rank] + n_wild == 5) check_result[CR_FIVE_OF_A_KIND] = rank;
// 			}
    		
    		if (cnt + n_wild == 4) check_result[CR_FOUR_OF_A_KIND] = rank;
	 		if (cnt + n_wild == 5) check_result[CR_FIVE_OF_A_KIND] = rank;
	 		
	 		if (cnt == 3) three = true;
	 		if (cnt == 2) two++;
 			
 			if (rank_test[rank] > 1) posible_straight = false; // same rank, except deuces - no straight posible
 			
 			if (min > hold[i]) min = hold[i];
 			if (max < hold[i]) max = hold[i];
 			
 			if (min_rank > rank) min_rank = rank;
 			if (max_rank < rank) max_rank = rank;
 			
 			if (max_rank_up_to_K < rank && rank < 12) // up to K
            	 max_rank_up_to_K = rank;
 		}
 		
 		
 		if (n_wild == 4) check_result[CR_FOUR_DEUCES] = 1;
 		
 		
 		if ((min / 13 == max / 13) && (max - min < 13))
 		{
 			check_result[CR_FLUSH] = min / 13;
 		}
 		
 		// without wild card - seq is straight
        // if some cards are missing, (they will be wild cards) and diffrence is less then 5 its straight, 
        // note: check is frrom 0 to 12, x1 lowest card, x2 highest card in seq
 		if (posible_straight) 
        {        	 
        	 if ((max_rank) - (min_rank) < 5)
        	 {
        		 check_result[CR_STRAIGHT] = 1;
        	 }
         	 else if (max_rank == 12) // ace
         	 {
         		 if ((max_rank_up_to_K) < 4) // A2345
         		 {         			 
         			check_result[CR_STRAIGHT] = 1;
            	 }
         	 }
        }
        
        if (check_result[CR_STRAIGHT] > -1 && check_result[CR_FLUSH] > -1)
        {
        	check_result[CR_FOUR_OF_A_KIND] = -1;
        	
        	check_result[CR_STRAIGHT_FLUSH] = check_result[CR_FLUSH]; // suit
        	
        	if (min_rank >= 8 && max_rank <= 12)
        	{
        		if (n_wild == 0) check_result[CR_NATURAL_ROYAL_FLUSH] = check_result[CR_STRAIGHT_FLUSH];
        		else if (n_wild < 4)check_result[CR_WILD_ROYAL_FLUSH] = check_result[CR_STRAIGHT_FLUSH];
        	}
        }
    	
    	boolean fh = false;
    	if (n_wild == 0) // 3168
    	{
    		if (three && two == 2)
    			fh = true;
    	}
    	else if (n_wild == 1) // 9,504
    	{
    		if (three) fh = true;    		
    		else if ( two == 2) fh = true;
    	}
    	// 12,672
    	
    	
    	if (check_result[CR_FOUR_OF_A_KIND] > -1)
    	{
    		fh = false;
    		check_result[CR_FLUSH] = -1;
    		check_result[CR_STRAIGHT] = -1;
    	}
    	
    	if (fh)
    	{
    		check_result[CR_FULL_HOUSE] = 1;
    	}
    	
    	
    	if (three && n_wild == 0 && !fh && check_result[CR_FOUR_OF_A_KIND] == -1) // ok - 42,240
    	{
    		check_result[CR_THREE_OF_KIND] = 1;
    	}
    	
		if (n_wild == 1 && two == 1 && check_result[CR_FOUR_OF_A_KIND] == -1 ) // OK - 253440
			check_result[CR_THREE_OF_KIND] = 1;
    	
    	if (n_wild == 2 
    			&& check_result[CR_FOUR_OF_A_KIND] == -1 
    			&& check_result[CR_STRAIGHT] == -1 
    			&& check_result[CR_FLUSH] == -1 
    			&& check_result[CR_FIVE_OF_A_KIND] == -1 
    			&& check_result[CR_WILD_ROYAL_FLUSH] == -1) // ok - 59,400
    	{
    		check_result[CR_THREE_OF_KIND] = 1;
    	}
        
        return check_result;
    }
}
