package com.aza.vp.he;

public class CombinationGen
{
	private int[] a;
	private int n;
	private int r;
	private long numLeft;
	private long total;

	// ------------13.// Constructor14.//------------
	public CombinationGen(int n, int r)
	{
		if (r > n)
		{
			throw new IllegalArgumentException();
		}
		if (n < 1)
		{
			throw new IllegalArgumentException();
		}

		this.n = n;
		this.r = r;
		a = new int[r];
		total = Prob.combinations_k(n, r);
		reset();
	}

	public void reset()
	{
		for (int i = 0; i < a.length; i++)
		{
			a[i] = i;
		}
		numLeft = total;
	}

	// ------------------------------------------------41.//
	// Return number of combinations not yet generated42.
	// ------------------------------------------------43.
	public long getNumLeft()
	{
		return numLeft;
	}

	// Are there more combinations
	// -----------------------------49.
	public boolean hasMore()
	{
		return numLeft != 0;
	}

	// ------------------------------------53.
	// Return total number of combinations54.
	// ------------------------------------55.
	public long getTotal()
	{
		return total;
	}
	

	// Generate next combination (algorithm from Rosen p. 286)70.
	// --------------------------------------------------------71.
	public int[] getNext()
	{
		if (numLeft == total)
		{
			numLeft = numLeft - 1;
			return a;
		}
		int i = r - 1;
		while (a[i] == n - r + i)
		{
			i--;
		}
		a[i] = a[i] + 1;
		for (int j = i + 1; j < r; j++)
		{
			a[j] = a[i] + j - i;
		}
		numLeft = numLeft - 1;
		return a;
	}
	
	public static void main(String[] args)
	{
		//String[] elements = { "a", "b", "c", "d" };
		
		int elements[] = new int[47];
		for (int i = 0; i < elements.length; i++)
		{
			elements[i] = i;
			
		}
		int[] indices;
				
		int cnt = 0;
		
		CombinationGen x = new CombinationGen(elements.length, 5);
		
		System.out.println(x.hasMore());
		
		while (x.hasMore())
		{
			//combination = new StringBuffer();
			indices = x.getNext();
			for (int i = 0; i < indices.length; i++)
			{
				//combination.append(elements[indices[i]]);
				
			}
			
			cnt++;
			//System.out.println(combination.toString());
		}
		
		System.out.println(cnt);
		
		System.out.println(Prob.combinations_k(52, 3));
	}
}