package com.aza.vp.he;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;


public class Prob
{
	// n < 64	
	public static <T> Set<Set<T>> powerSet(List<T> originalSet)
	{
		List<T> list = new ArrayList<T>(originalSet);
		int n = list.size();

		Set<Set<T>> powerSet = new HashSet<Set<T>>();

		for( long i = 0; i < (1 << n); i++)
		{
		    Set<T> element = new HashSet<T>();
		    
		    for( int j = 0; j < n; j++ )
		        if( (i >> j) % 2 == 1 ) element.add(list.get(j));
		    
		    powerSet.add(element);
		}

		return powerSet;
	}
	
	
	
	
	
	public static long variations(int n, int k)
	{
		return factoriel(n) / factoriel(n - k);
	}
	
	public static double variations_with_repetition(int n, int k)
	{
		return Math.pow(n, k);
	}
	
	public static long permutations(int n)
	{
		return factoriel(n);
	}
	
	public static long permutations_with_repetition(int n)
	{
		int sum = 0;
		int p = 0;
		for (int i = 1; i <= n; i++)
		{
			sum += i;			
			p *= factoriel(i);
		}
		
		return factoriel(sum) / p;
	}
	
	public static long combinations(int n, int k)
	{
		return factoriel(n) / (factoriel(n - k) * factoriel(k) );
	}
	
	public static long combinations_k(int n, int k)
	{
		if (n < k) return 0;
		
		if (k <= 0) return 1;
		
		//return factoriel(n) / (factoriel(n - k) * factoriel(k) );
		return factoriel_k(n, n - k) / factoriel(k) ;
	}
	
	public static long combinations_with_repetition(int n, int k)
	{
		return combinations(n + k - 1, k);
	}
	
	public static long combinations_iter(int n, int k)
	{
		if (n < k) return 0;
		
		long res = 1;
		
		for (double i = 1; i <= k; i++)
		{
			double x = (n - (k - i) ) / i;
			res *= x;
		}
		
		return res;
	}
	
	// n < 25, long
	public static long factoriel(int n)
	{
		if (n == 0) return 1;
		
		long a = n;
		while(--n > 0)
		{
			a *= n;
		}
		return a;
	}
	
	public static long factoriel_k(int n, int k) // down to k
	{
		if (n == 0) return 1;
		
		long a = n;
		while(--n > k)
		{
			a *= n;
		}
		return a;
	}
	
	public static void pascal_triangle()
	{
		int n = 10;
		for (int k = 0; k <= n; k++)
		{
			for (int i = 0; i <= k; i++)
			{
				System.out.print(" " + combinations(k, i));
			}
			System.out.println();
		}
		
	}
	
	
	public static void test1()
	{
		List<Integer> originalSet = new ArrayList<Integer>();
		originalSet.add(1);
		originalSet.add(2);
		originalSet.add(3);
		originalSet.add(4);
		originalSet.add(5);
		
		Set<Set<Integer>> power_set = Prob.powerSet(originalSet);
		
		Iterator<Set<Integer>> it = power_set.iterator();
		while (it.hasNext())
		{
			Set<Integer> set = it.next();
			System.out.println(set);
		}
		
		System.out.println("n subsets: " + power_set.size());
	}
	
	
	public static void test2()
	{
		List<String> originalSet = new ArrayList<String>();
		originalSet.add("A");
		originalSet.add("B");
		originalSet.add("C");
		originalSet.add("D");
		originalSet.add("E");
		
		Set<Set<String>> power_set = Prob.powerSet(originalSet);
		
		Iterator<Set<String>> it = power_set.iterator();
		while (it.hasNext())
		{
			Set<String> set = it.next();
			System.out.println(set);
		}
		
		System.out.println("n subsets: " + power_set.size());
	}
	
	public static void test3()
	{
		test2();
		int n = 5;
		int n_sets = 0;
		for (int i = 0; i <= n; i++)
		{
			System.out.println("comb: " + combinations(n, i));
			n_sets += combinations(n, i);
		}
		
		System.out.println("n subsets: " + n_sets);
	}
	
	public static void main(String args[])
	{
//		long res = factoriel(25);
//		//int res = (int)factoriel(16);
		test3();
//		System.out.println(res);
		
//		int n = 11;
//		int k = 5;
//		System.out.println("xxx: " + factoriel(n));
//		System.out.println("xxx: " + factoriel_k(n, 0));
//		
//		System.out.println("xxx: " + combinations(n, k));
//		System.out.println("xxx: " + combinations_k(n, k));
//		System.out.println("xxx: " + combinations_k(52, 5));
		
		pascal_triangle();
	}
	
	

}
