package com.aza.vp.he;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import com.aza.vp.game.DeucesWild;
import com.aza.vp.game.Poker;
import com.aza.vp.he.HoldEv.PayoutType;


public class Test_8_BF_Evaluate
{
	Poker poker;
	
	int deck_all_cards[];

	// DEUCES_WILD, JOKER_POKER
	public Test_8_BF_Evaluate()
	{
		// test_initial();
		

		test();
		
	}
	
	public void test()
	{
		poker = Poker.createGame(Poker.TYPE_DEUCES_WILD);
		//poker = Poker.createGame(Poker.TYPE_JOKER_POKER);
		
		deck_all_cards = new int[poker.getNumCards()];
		for (int i = 0; i < deck_all_cards.length; i++)
		{
			deck_all_cards[i] = i;
		}
		

		System.out.println("poker.getNumCards(): " + (poker.getNumCards()));
		
		int payout[] = poker.getPayoutTable();
		
		//int hand[] = Poker.getHand("KC", "KD", "KS", "10D", "10C");
		int hand[] = Poker.getHand("KC", "QD", "JD", "10D", "2D");
		//int hand[] = Poker.getHand("KC", "QD", "JD", "10D", "8D");
				
		
		HoldEv he[] = power_set(hand, payout);
		
		System.out.println("--------------------------------------------------------");
		Poker.print_hand(hand);
		System.out.println("--------------------------------------------------------");
		
		Utils.printHoldEv(he, poker);
	}
	
	public void test_initial()
	{
		deck_all_cards = new int[52];
		for (int i = 0; i < deck_all_cards.length; i++)
		{
			deck_all_cards[i] = i;
		}
		
		poker = Poker.createGame(Poker.TYPE_DEUCES_WILD);;
		int wild_rank = 0;
		int payout[] = poker.getPayoutTable();
		HoldEv he_dw = evaluate_hold_initial(payout, wild_rank);		
		Utils.printHoldEv(he_dw, poker);
		
		
		poker = Poker.createGame(Poker.TYPE_JACKS_OR_BETTER);;
		wild_rank = -1;
		payout = poker.getPayoutTable();
		HoldEv he_job = evaluate_hold_initial(payout, wild_rank);		
		Utils.printHoldEv(he_job, poker);
		
		poker = Poker.createGame(Poker.TYPE_TENS_OR_BETTER);
		wild_rank = -1;
		payout = poker.getPayoutTable();
		HoldEv he_tob = evaluate_hold_initial(payout, wild_rank);		
		Utils.printHoldEv(he_tob, poker);
		
		poker = Poker.createGame(Poker.TYPE_DOUBLE_BONUS);
		wild_rank = -1;
		payout = poker.getPayoutTable();
		HoldEv he_db = evaluate_hold_initial(payout, wild_rank);		
		Utils.printHoldEv(he_db, poker);
		
		poker = Poker.createGame(Poker.TYPE_JOKER_POKER);
		wild_rank = -1;
		payout = poker.getPayoutTable();
		deck_all_cards = new int[53];
		for (int i = 0; i < deck_all_cards.length; i++)
		{
			deck_all_cards[i] = i;
		}		
		HoldEv he_jp = evaluate_hold_initial(payout, wild_rank);		
		Utils.printHoldEv(he_jp, poker);
	}
	
	
//	static double comb_cl_47[] = 
//		{
//		1,
//		47,
//		1081,
//		16215,
//		178365,
//		1533939
//		};
//	
//	static double comb_cl_48[] = 
//		{
//		1,
//		48,
//		1128,
//		17296,
//		194580,
//		1712304
//		};
//	
	
	
	
	
	public HoldEv[] power_set(int hand[], int payout[])
	{
		Set<Set<Integer>> power_set = get_power_set();
		
		HoldEv he[] = new HoldEv[power_set.size()];
		
		int i = 0;
		
		Iterator<Set<Integer>> it = power_set.iterator();
		while (it.hasNext())
		{
			Set<Integer> set = it.next();
			boolean h[] = getHold(set);
			HoldEv ev = evaluate_hold(hand, h, payout);
			he[i++] = ev;
		}
		
		return he;
	}
	
	public static boolean[] getHold(Set<Integer> set)
	{
		boolean h[] = new boolean[5];
		
		Iterator<Integer> it = set.iterator();
		while (it.hasNext())
		{
			int i = it.next();
			h[i] = true;			
		}
		return h;
	}
	
	public static Set<Set<Integer>>  get_power_set()
	{
		List<Integer> originalSet = new ArrayList<Integer>();
		originalSet.add(0);
		originalSet.add(1);
		originalSet.add(2);
		originalSet.add(3);
		originalSet.add(4);
		
		Set<Set<Integer>> power_set = Prob.powerSet(originalSet);
		
		return power_set;
	}
	
	
	public HoldEv evaluate_hold(int hand[], boolean h[], int payout[])
	{
		int counter[] = new int[payout.length];
		
		int deck[] = subFromDeck(deck_all_cards, hand);
		int hold[] = Utils.getHold(hand, h, Utils.getHoldCnt(h));
		//int outs[] = Utils.getOUTS(hand, h, Utils.getDropCnt(h));
		
		int wild_rank = poker.getWildCardRank();
		int n_wild = 0;
		
		int test_hold[] = new int[5];
		for (int i = 0; i < hold.length; i++)
		{
			test_hold[i] = hold[i];
			
			if (test_hold[i] % 13 == wild_rank || test_hold[i] > 51) n_wild++;
		}
		
		int n_draw =  5 - hold.length;
		
		CombinationGen x = new CombinationGen(deck.length, n_draw);
		
		int[] indices;
		while (x.hasMore())
		{
			int n_wild_draw = 0;
			
			indices = x.getNext();
			for (int i = 0; i < indices.length; i++)
			{
				int j = hold.length + i;
				test_hold[j] = deck[indices[i]];
				//if (test_hold[hold.length + i] % 13 == wild_rank) n_wild_draw++;
				if (test_hold[j] % 13 == wild_rank || test_hold[j] > 51) n_wild_draw++;
			}
			int result = poker.checkHand(test_hold, n_wild + n_wild_draw);
			//int result = JokerPoker.checkHand_static(test_hold, n_wild + n_wild_draw);
			//int result = DeucesWild.checkHand_static(test_hold, n_wild + n_wild_draw);
			//int result = DeucesWild.check_ALL_best(test_hold, n_wild + n_wild_draw, 0);
			//int check_result[] = Poker.check_ALL(test_hold, deuces_count(test_hold), 0);			
			//int check_result[] = Poker.check_ALL_B(test_hold, deuces_count(test_hold), 0);
			
			if (result != DeucesWild.NOTHING)
				counter[result]++;
			
		}
		
		
		
		HoldEv he = new HoldEv();
		he.payout_type = new PayoutType[counter.length];
		
		//double total_comb = comb_cl_47[n_draw];
		double total_comb = Prob.combinations_k(deck.length, n_draw);
		
		double sum_exp = 0;
		long sum_payout = 0;
		
		for (int i = 0; i < counter.length; i++)
		{
			int num_comb = counter[i];
			double prob = num_comb / total_comb;
			double exp = prob * payout[i];
			
			prob = round(prob);
			exp = round(exp);
			
			he.payout_type[i] =  new PayoutType(i, exp, num_comb, prob);
			
			sum_exp += exp;
			sum_payout += num_comb * payout[i];
		}
		
		sum_exp = round(sum_exp);
		
		he.exp = sum_exp;		
		he.n_draw = n_draw;		
		he.cards_held = hold;		
		he.payout = sum_payout;
		
		
		return he;
	}
	
	
	public HoldEv evaluate_hold_initial(int payout[], int wild_rank)
	{
		int counter[] = new int[payout.length];
		
		int test_hold[] = new int[5];
		
		int deck[] = deck_all_cards;
		
		int n_draw = 5;
		
		CombinationGen x = new CombinationGen(deck.length, n_draw);
		
		int[] indices;
		while (x.hasMore())
		{
			int n_wild_draw = 0;
			
			indices = x.getNext();
			for (int i = 0; i < indices.length; i++)
			{		
				test_hold[i] = deck[indices[i]];
				if (test_hold[i] % 13 == wild_rank || test_hold[i] > 51) n_wild_draw++;
				
				//if (test_hold[i]  == 52) n_wild_draw++; // joker poker
			}
			//int result = DeucesWild.checkHand_static(test_hold, n_wild_draw, 0);
			int result = poker.checkHand(test_hold, n_wild_draw);
			
			if (result != Poker.NOTHING)
				counter[result]++;
		}	
		
		HoldEv he = new HoldEv();
		he.payout_type = new PayoutType[counter.length];
		
		double total_comb = Prob.combinations_k(deck.length, n_draw);
		
//		double x3 = Prob.combinations_k(52, 5) +
//				Prob.combinations_k(52, 4) * Prob.combinations_k(47, 1) +
//				Prob.combinations_k(52, 3) * Prob.combinations_k(47, 2) +
//				Prob.combinations_k(52, 2) * Prob.combinations_k(47, 3) +
//				Prob.combinations_k(52, 1) * Prob.combinations_k(47, 4) +
//				Prob.combinations_k(52, 0) * Prob.combinations_k(47, 5) * 4
//				;
//		
//		double x4 = Prob.combinations_k(52, 5) * Prob.combinations_k(47, 5) * 4/12.0;
//		double x1 = Prob.combinations_k(52, 5) * Prob.combinations_k(47, 5) * 5;
//		double x2 = Prob.combinations_k(52, 5) * Prob.combinations_k(47, 5) * 5 / 12.0;
//		
//		System.out.println(String.format("%f", x1 * .000022083864));
//		System.out.println(String.format("%f", x1));
//		System.out.println(String.format("%f", x2 ));
//		
//		
//		System.out.println(String.format("%f", 493512264 / 19933230517200.0));
//		System.out.println(String.format("%f", 2178883296L / 19933230517200.0));
//		System.out.println(String.format("%f", 47093167764L / 19933230517200.0));
//		
//		System.out.println(String.format("%f", x3));
//		System.out.println(String.format("%f", x4));
		
		//System.out.println(String.format("%f", 2598960 * 800.0));
		
		
		double sum_exp = 0;
		long sum_payout = 0;
		
		for (int i = 0; i < counter.length; i++)
		{
			int num_comb = counter[i];
			double prob = num_comb / total_comb;
			double exp = prob * payout[i];
			
			prob = round(prob);
			exp = round(exp);
			
			he.payout_type[i] =  new PayoutType(i, exp, num_comb, prob);
			
			sum_exp += exp;
			sum_payout += num_comb * payout[i];
		}
		
		sum_exp = round(sum_exp);
		
		he.exp = sum_exp;		
		he.n_draw = n_draw;		
		//he.cards_held = hold;		
		he.payout = sum_payout;
		
		
		return he;
	}
	
	
	//  1.382979	
	public double Exp(long n, int draw, int card_left, int payout_type) // sum oaf all types in payout
	{		 
		double d = Prob.combinations_k(card_left, draw);
		//double d = comb_cl_47[draw];
		
		double e = (n / d) * poker.getPayout(payout_type);
		
		return e;
	}
	
	double round(double a)
	{
		a *= 1000000;
		a = Math.round(a);
		return a /= 1000000;		
	}
	
	
	public int deuces_count(int hold[])
	{
		int c = 0;
		for (int i = 0; i < hold.length; i++)
		{
			if (hold[i] % 13 == 0) c++;
		}
		return c;
	}
	
	public int[] subFromDeck(int deck[], int hand[])
	{
		int d[] = new int[deck.length - hand.length];
		int j = 0;
		for (int i = 0; i < deck.length; i++)
		{
			if (!Utils.contains(hand, deck[i]))
			{
				d[j++] = deck[i];
			}
		}
		return d;
	}
	
	public static void main(String a[])
	{
		new Test_8_BF_Evaluate();
	}
}
