package com.aza.vp.he;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import com.aza.vp.game.JacksOrBetter;
import com.aza.vp.game.Poker;
import com.aza.vp.game.TensOrBetter;
import com.aza.vp.he.HoldEv.PayoutType;


public class Test_9_Evaluate
{
	// Jacks o b, Tens or better, DoubleBonus
	public Test_9_Evaluate()
	{		
		test();
	}
	
	public void test()
	{
		//int hand[] = Poker.getHand("KC", "KD", "KS", "10D", "10C");
		int hand[] = Poker.getHand("KC", "QD", "JD", "10D", "8D");
		
		//int hand[] = Poker.getHand("AC", "QD", "JC", "10C", "9C");
		//boolean h[] = {true, true, true, true, false};							// 0.5319148936170213
		//boolean h[] = {false, true, true, true, true};							// 0.8085106382978723
		//boolean h[] = {true, false, true, true, true};							// 1.2765957446808511
		//boolean h[] = {false, false, true, true, true};							// 0.6503237742830713
		//boolean h[] = {true, false, true, true, false};							// 1.2691951896392228		
		
		
		poker = Poker.createGame(Poker.TYPE_JACKS_OR_BETTER);
		HoldEv he[] = power_set(hand, poker);
	
		//poker = Poker.createGame(Poker.TYPE_TENS_OR_BETTER);
		//HoldEv he[] = power_set(hand, poker);
		
//		poker = new DoubleBonusPoker();		
//		HoldEv he[] = power_set(hand, poker);
		
		System.out.println("--------------------------------------------------------");
		Poker.print_hand(hand);
		System.out.println("--------------------------------------------------------");
		
		//Arrays.sort(he, new HoldEvComp());
		
		Utils.printHoldEv(he, poker);
	}
	
	class HoldEvComp implements Comparator<HoldEv>
	{
		@Override
		public int compare(HoldEv v1, HoldEv v2)
		{
			if(v1.exp > v2.exp) return -1;
			if(v1.exp < v2.exp) return 1;
			return 0;
		}
	}

	
	static double comb_cl_47[] = 
		{
		1,
		47,
		1081,
		16215,
		178365,
		1533939
		};
	
	
	public long[] evaluate_hold_JoB(int hold[], int outs[], int n_draw, int payout_len)
	{
		long counter[] = new long[payout_len];
		
		long num_royal_flush = num_royal_flush(hold, outs, n_draw);
		
		long num_four_of_a_kind = num_four_of_a_kind(hold, outs, n_draw);		
		
		long num_three_of_a_kind = num_three_of_a_kind(hold, outs, n_draw);
		long num_full_house = num_of_full_houses(hold, outs, n_draw);
		long num_two_pairs = num_of_two_pairs(hold, outs, n_draw);
		
		//long num_one_pairs = num_of_one_pairs(hold, outs, n_draw, 9); // jacs
		long num_one_pairs = num_of_one_pairs_comb(hold, outs, n_draw, 9); // jacs
		
		long num_straight_flush = num_of_straight_flushes(hold, outs, n_draw);		
		long num_flushes = num_flush(hold, outs, n_draw);
		long num_straights = num_of_straights(hold, outs, n_draw);
		
		num_straight_flush = num_straight_flush - num_royal_flush;
		num_straights = num_straights - num_straight_flush - num_royal_flush;
		num_flushes = num_flushes - num_straight_flush - num_royal_flush;
		
		int i = 0;
		counter[i++] = num_royal_flush;
		counter[i++] = num_straight_flush;
		counter[i++] = num_four_of_a_kind;
		counter[i++] = num_full_house;
		counter[i++] = num_flushes;
		counter[i++] = num_straights;
		counter[i++] = num_three_of_a_kind;
		counter[i++] = num_two_pairs;
		counter[i++] = num_one_pairs;
		
		return counter;
	}
	
	public long[] evaluate_hold_ToB(int hold[], int outs[], int n_draw, int payout_len)
	{
		long counter[] = new long[payout_len];
		
		long num_royal_flush = num_royal_flush(hold, outs, n_draw);		
		long num_four_of_a_kind = num_four_of_a_kind(hold, outs, n_draw);
		long num_three_of_a_kind = num_three_of_a_kind(hold, outs, n_draw);
		long num_full_house = num_of_full_houses(hold, outs, n_draw);
		long num_two_pairs = num_of_two_pairs(hold, outs, n_draw);
		
		long num_one_pairs = num_of_one_pairs(hold, outs, n_draw, 8); // tens
		
		long num_straight_flush = num_of_straight_flushes(hold, outs, n_draw);		
		long num_flushes = num_flush(hold, outs, n_draw);
		long num_straights = num_of_straights(hold, outs, n_draw);
		
		num_straight_flush = num_straight_flush - num_royal_flush;
		num_straights = num_straights - num_straight_flush - num_royal_flush;
		num_flushes = num_flushes - num_straight_flush - num_royal_flush;
		
		int i = 0;
		counter[i++] = num_royal_flush;
		counter[i++] = num_straight_flush;
		counter[i++] = num_four_of_a_kind;
		counter[i++] = num_full_house;
		counter[i++] = num_flushes;
		counter[i++] = num_straights;
		counter[i++] = num_three_of_a_kind;
		counter[i++] = num_two_pairs;
		counter[i++] = num_one_pairs;
		
		return counter;
	}
	
	public long[] evaluate_hold_DB(int hold[], int outs[], int n_draw, int payout_len)
	{
		long counter[] = new long[payout_len];
		
		long num_royal_flush = num_royal_flush(hold, outs, n_draw);
		
		//long num_four_of_a_kind = num_four_of_a_kind(hold, outs, n_draw);
		
		long num_four_aces = num_four_aces(hold, outs, n_draw);
		long num_2_3_4 = num_four_2_3_4(hold, outs, n_draw);
		long num_four_5_ko_K = num_four_5_to_K(hold, outs, n_draw);
		
		long num_three_of_a_kind = num_three_of_a_kind(hold, outs, n_draw);
		long num_full_house = num_of_full_houses(hold, outs, n_draw);
		long num_two_pairs = num_of_two_pairs(hold, outs, n_draw);		
		long num_one_pairs = num_of_one_pairs(hold, outs, n_draw, 9); // jacs
		long num_straight_flush = num_of_straight_flushes(hold, outs, n_draw);		
		long num_flushes = num_flush(hold, outs, n_draw);
		long num_straights = num_of_straights(hold, outs, n_draw);
		
		num_straight_flush = num_straight_flush - num_royal_flush;
		num_straights = num_straights - num_straight_flush - num_royal_flush;
		num_flushes = num_flushes - num_straight_flush - num_royal_flush;
		
		int i = 0;
		counter[i++] = num_royal_flush;
		counter[i++] = num_straight_flush;
		counter[i++] = num_four_aces;
		counter[i++] = num_2_3_4;
		counter[i++] = num_four_5_ko_K;
		counter[i++] = num_full_house;
		counter[i++] = num_flushes;
		counter[i++] = num_straights;
		counter[i++] = num_three_of_a_kind;
		counter[i++] = num_two_pairs;
		counter[i++] = num_one_pairs;
		
		return counter;
	}
	
	
	
	
	
	public HoldEv evaluate_hold(int hand[], boolean h[],  Poker poker)
	{
		int hold[] = getHold(hand, h, getHoldCnt(h));
		int outs[] = getOUTS(hand, h, getDropCnt(h));
		
		int payout[] = poker.getPayoutTable();
		int poker_type = poker.getType();
		
		int n_draw = getDropCnt(h);
		
		long counter[] = null;
		if (poker_type == Poker.TYPE_JACKS_OR_BETTER)
			counter = evaluate_hold_JoB(hold, outs, n_draw, payout.length);
		if (poker_type == Poker.TYPE_TENS_OR_BETTER)
			counter = evaluate_hold_ToB(hold, outs, n_draw, payout.length);
		if (poker_type == Poker.TYPE_DOUBLE_BONUS)
			counter = evaluate_hold_DB(hold, outs, n_draw, payout.length);
				
		HoldEv he = new HoldEv();
		he.payout_type = new PayoutType[counter.length];
		
		double total_comb = comb_cl_47[n_draw];
		//double total_comb = Prob.combinations_k(deck.length, n_draw);
		
		double sum_exp = 0;
		long sum_payout = 0;
		
		for (int i = 0; i < counter.length; i++)
		{
			int num_comb = (int)counter[i];
			double prob = num_comb / total_comb;
			double exp = prob * payout[i];
			
			prob = round(prob);
			exp = round(exp);
			
			he.payout_type[i] =  new PayoutType(i, exp, num_comb, prob);
			
			sum_exp += exp;
			sum_payout += num_comb * payout[i];
		}
		
		sum_exp = round(sum_exp);
		
		he.exp = sum_exp;		
		he.n_draw = n_draw;		
		he.cards_held = hold;		
		he.payout = sum_payout;
		
//		double prob_straight = num_straights / comb;
//		double prob_flushes = num_flushes / comb;	
//		double prob_straight_flushes = num_straight_flush / comb;
//		double prob_four_of_a_kind = num_four_of_a_kind / comb;
//		double prob_three_of_a_kind = num_three_of_a_kind / comb;
//		double prob_full_house = num_full_house / comb;
//		double prob_two_pairs = num_two_pairs / comb;
//		double prob_one_pair = num_one_pairs / comb;
//		double prob_royal_flush = num_royal_flush / comb;
//			
//		double exp_straight = prob_straight * poker.getPayout(JacksOrBetter.STRAIGHT);
//		double exp_flushes = prob_flushes * poker.getPayout(JacksOrBetter.FLUSH);		
//		double exp_straight_flushes = prob_straight_flushes * poker.getPayout(JacksOrBetter.STRAIGHT_FLUSH);
//		double exp_four_of_a_kind = prob_four_of_a_kind * poker.getPayout(JacksOrBetter.FOUR_OF_A_KIND);
//		double exp_three_of_a_kind = prob_three_of_a_kind * poker.getPayout(JacksOrBetter.THREE_OF_KIND);
//		double exp_full_house = prob_full_house * poker.getPayout(JacksOrBetter.FULL_HOUSE);
//		double exp_two_pairs = prob_two_pairs * poker.getPayout(JacksOrBetter.TWO_PAIRS);
//		double exp_one_pair = prob_one_pair * poker.getPayout(JacksOrBetter.HIGH_PAIR);
//		double exp_royal_flush = prob_royal_flush * poker.getPayout(JacksOrBetter.ROYAL_FLUSH);
//		
//		double exp = exp_royal_flush + exp_four_of_a_kind + exp_three_of_a_kind + exp_two_pairs + exp_straight + exp_flushes + exp_straight_flushes + exp_one_pair + exp_full_house;
//		
//		exp = round(exp);
//		
//		exp_royal_flush = round(exp_royal_flush);
//		exp_four_of_a_kind = round(exp_four_of_a_kind);
//		exp_three_of_a_kind = round(exp_three_of_a_kind);
//		exp_two_pairs = round(exp_two_pairs);
//		exp_straight = round(exp_straight);
//		exp_flushes = round(exp_flushes);
//		exp_straight_flushes = round(exp_straight_flushes);
//		exp_one_pair = round(exp_one_pair);
//		exp_full_house = round(exp_full_house);
//		
//		
//		prob_straight = round(prob_straight);
//		prob_flushes = round(prob_flushes);
//		prob_straight_flushes = round(prob_straight_flushes);
//		prob_four_of_a_kind = round(prob_four_of_a_kind);
//		prob_three_of_a_kind = round(prob_three_of_a_kind);
//		prob_full_house = round(prob_full_house);
//		prob_two_pairs = round(prob_two_pairs);
//		prob_one_pair = round(prob_one_pair);
//		prob_royal_flush = round(prob_royal_flush);
//		
//		
//		PayoutType royal_flush = new PayoutType(JacksOrBetter.ROYAL_FLUSH, exp_royal_flush, num_royal_flush, prob_royal_flush);
//		PayoutType four_of_a_kind = new PayoutType(JacksOrBetter.FOUR_OF_A_KIND, exp_four_of_a_kind, num_four_of_a_kind, prob_four_of_a_kind);
//		PayoutType three_of_a_kind= new PayoutType(JacksOrBetter.THREE_OF_KIND, exp_three_of_a_kind, num_three_of_a_kind, prob_three_of_a_kind);		
//		PayoutType two_pairs = new PayoutType(JacksOrBetter.TWO_PAIRS, exp_two_pairs, num_two_pairs, prob_two_pairs);		
//		PayoutType one_pair = new PayoutType(JacksOrBetter.HIGH_PAIR, exp_one_pair, num_one_pairs, prob_one_pair);
//		PayoutType straight = new PayoutType(JacksOrBetter.STRAIGHT, exp_straight, num_straights, prob_straight);
//		PayoutType straight_flush = new PayoutType(JacksOrBetter.STRAIGHT_FLUSH, exp_straight_flushes, num_straight_flush, prob_straight_flushes);
//		PayoutType flush = new PayoutType(JacksOrBetter.FLUSH, exp_flushes, num_flushes, prob_flushes);		
//		PayoutType full_house = new PayoutType(JacksOrBetter.FULL_HOUSE, exp_full_house, num_full_house, prob_full_house);
//		
//		
//		HoldEv he = new HoldEv();
//		he.payout_type = new PayoutType[9];
//		int i = 0;
//		he.payout_type[i++] = royal_flush;
//		he.payout_type[i++] = four_of_a_kind;
//		he.payout_type[i++] = full_house;
//		he.payout_type[i++] = straight_flush;
//		he.payout_type[i++] = flush;
//		he.payout_type[i++] = straight;		
//		he.payout_type[i++] = three_of_a_kind;
//		he.payout_type[i++] = two_pairs;
//		he.payout_type[i++] = one_pair;
//		
//		he.exp = exp;
//		
//		he.n_draw = n_draw;
//		
//		he.cards_held = hold;
//		
//		he.payout = 					num_royal_flush *  poker.getPayout(JacksOrBetter.ROYAL_FLUSH) + 
//											num_four_of_a_kind  * poker.getPayout(JacksOrBetter.FOUR_OF_A_KIND)+
//											num_three_of_a_kind  * poker.getPayout(JacksOrBetter.THREE_OF_KIND)+
//											num_two_pairs * poker.getPayout(JacksOrBetter.TWO_PAIRS) + 
//											num_straights * poker.getPayout(JacksOrBetter.STRAIGHT) +
//											num_flushes * poker.getPayout(JacksOrBetter.FLUSH) +
//											num_straight_flush * poker.getPayout(JacksOrBetter.STRAIGHT_FLUSH) +
//											num_one_pairs  * poker.getPayout(JacksOrBetter.HIGH_PAIR)+
//											num_full_house * poker.getPayout(JacksOrBetter.FULL_HOUSE);
		
		
		return he;
	}
	
	double round(double a)
	{
		a *= 1000000;
		a = Math.round(a);
		return a /= 1000000;		
	}
	
	public HoldEv[] power_set(int hand[], Poker poker)
	{
		Set<Set<Integer>> power_set = get_power_set();
		
		HoldEv he[] = new HoldEv[power_set.size()];
		
		int i = 0;
		
		Iterator<Set<Integer>> it = power_set.iterator();
		while (it.hasNext())
		{
			Set<Integer> set = it.next();
			boolean h[] = getHold(set);
			HoldEv ev = evaluate_hold(hand, h, poker);
			he[i++] = ev;
		}
		
		return he;
	}
	
	public static boolean[] getHold(Set<Integer> set)
	{
		boolean h[] = new boolean[5];
		
		Iterator<Integer> it = set.iterator();
		while (it.hasNext())
		{
			int i = it.next();
			h[i] = true;			
		}
		return h;
	}
	
	public static Set<Set<Integer>>  get_power_set()
	{
		List<Integer> originalSet = new ArrayList<Integer>();
		originalSet.add(0);
		originalSet.add(1);
		originalSet.add(2);
		originalSet.add(3);
		originalSet.add(4);
		
		Set<Set<Integer>> power_set = Prob.powerSet(originalSet);
		
		return power_set;
	}
	
	public long num_royal_flush(int hold[], int outs[], int n_draw)
	{
		long res = 0;
		for (int a = 0; a < 4; a++)
		{
			int c1 = a * 13 + 8;
			int c2 = a * 13 + 9;
			int c3 = a * 13 + 10;
			int c4 = a * 13 + 11;
			int c5 = a * 13 + 12;
			
			int straight[] = {c1, c2, c3, c4, c5};
			
			if (posible_straght(straight, hold, outs, n_draw)) res++;
		}
		return res;
	}
	
	public long num_flush(int hold[], int outs[], int n_draw)
	{
		long res = 0;
		for (int i = 0; i < 4; i++)
		{			
			int ns_hold = n_of_suit(i, hold);
			
			int n = 13 - n_of_suit(i, outs) - ns_hold;
			int k = 5 - ns_hold;
			
			if (ns_hold + n_draw == 5)
			{
				long co = Prob.combinations_k(n, k);
				res += co;
			}
		}
		return res;
	}
	
	public long num_four_of_a_kind(int hold[], int outs[], int n_draw)
	{
		long res = 0;
		for (int i = 0; i < 13; i++)
		{			
			int nr_hold = n_of_rank(i, hold);				
			int n1 = 4 - n_of_rank(i, outs) - nr_hold;
			int k1 = 4 - nr_hold;
			
			for (int j = 0; j < 13; j++)
			{
				if (j == i ) continue;
				
				int nr_hold_j = n_of_rank(j, hold);				
				int n2 = 4 - n_of_rank(j, outs) - nr_hold_j;
				int k2 = 1 - nr_hold_j;
				
				if (k2 < 0) k2 = 0;
				
				if (k1 + k2 == n_draw)
				{
					long co = Prob.combinations_k(n1, k1) * Prob.combinations_k(n2, k2);
					res += co;
				}				
			}
		}
		return res;
	}
	
	
	public long num_four_aces(int hold[], int outs[], int n_draw)
	{
		long res = 0;
		int i = 12;
		//for (int i = 0; i < 13; i++)
		{			
			int nr_hold = n_of_rank(i, hold);				
			int n1 = 4 - n_of_rank(i, outs) - nr_hold;
			int k1 = 4 - nr_hold;
			
			for (int j = 0; j < 13; j++)
			{
				if (j == i ) continue;
				
				int nr_hold_j = n_of_rank(j, hold);				
				int n2 = 4 - n_of_rank(j, outs) - nr_hold_j;
				int k2 = 1 - nr_hold_j;
				
				if (k2 < 0) k2 = 0;
				
				if (k1 + k2 == n_draw)
				{
					long co = Prob.combinations_k(n1, k1) * Prob.combinations_k(n2, k2);
					res += co;
				}				
			}
		}
		return res;
	}
	
	public long num_four_2_3_4(int hold[], int outs[], int n_draw)
	{
		long res = 0;
		
		for (int i = 0; i < 3; i++) // 2, 3, 4
		{			
			int nr_hold = n_of_rank(i, hold);				
			int n1 = 4 - n_of_rank(i, outs) - nr_hold;
			int k1 = 4 - nr_hold;
			
			for (int j = 0; j < 13; j++)
			{
				if (j == i ) continue;
				
				int nr_hold_j = n_of_rank(j, hold);				
				int n2 = 4 - n_of_rank(j, outs) - nr_hold_j;
				int k2 = 1 - nr_hold_j;
				
				if (k2 < 0) k2 = 0;
				
				if (k1 + k2 == n_draw)
				{
					long co = Prob.combinations_k(n1, k1) * Prob.combinations_k(n2, k2);
					res += co;
				}				
			}
		}
		return res;
	}
	
	public long num_four_5_to_K(int hold[], int outs[], int n_draw)
	{
		long res = 0;
		
		for (int i = 3; i < 12; i++)
		{			
			int nr_hold = n_of_rank(i, hold);				
			int n1 = 4 - n_of_rank(i, outs) - nr_hold;
			int k1 = 4 - nr_hold;
			
			for (int j = 0; j < 13; j++)
			{
				if (j == i ) continue;
				
				int nr_hold_j = n_of_rank(j, hold);				
				int n2 = 4 - n_of_rank(j, outs) - nr_hold_j;
				int k2 = 1 - nr_hold_j;
				
				if (k2 < 0) k2 = 0;
				
				if (k1 + k2 == n_draw)
				{
					long co = Prob.combinations_k(n1, k1) * Prob.combinations_k(n2, k2);
					res += co;
				}				
			}
		}
		return res;
	}
	
	
	public long num_four_of_a_kind_1(int hold[], int outs[], int n_draw)
	{		
		long res = 0;
		for (int i = 0; i < 13; i++)
		{
			int nr_hold = n_of_rank(i, hold);				
			int n = 4 - n_of_rank(i, outs) - nr_hold;
			int k = 4 - nr_hold;
			
			for (int j = 0; j < 52; j++)
			{
				if (j % 13 == i ) continue;
				
				if (Utils.contains(outs, j)) continue;
				
				int h = 0;
				if (Utils.contains(hold, j)) h = 1;
				
				if (nr_hold + h + n_draw == 5)
				{
					long co = Prob.combinations_k(n, k);
					res += co;
				}				
			}
		}
		return res;
	}
	
	public long num_three_of_a_kind_including_FH(int outs[]) // three
	{		
		long res = 0;
		for (int i = 0; i < 13; i++) // including full houses, sub later
		{
			int c2 = 48 - outs.length; // ?? if card from range is in outs?
			int c1 = 4 - n_of_rank(i, outs);
			long co = Prob.combinations_k(c1, 3) * Prob.combinations_k(c2, 2);
			
			res += co;
		}
		return res;
	}
	
	
	public long num_three_of_a_kind(int hold[], int outs[], int n_draw)
	{
		int res = 0;
		for (int a = 0; a < 13; a++)
		{			
			for (int b = 0; b < 13; b++)
			{
				if (b == a) continue;
				
				for (int c = 0; c < 13; c++)
				{
					if (c == a || c == b) continue;
					
					int nr_hold_a = n_of_rank(a, hold);				
					int n1 = 4 - n_of_rank(a, outs) - nr_hold_a;
					int k1 = 3 - nr_hold_a;
					
					
					int nr_hold_b = n_of_rank(b, hold);				
					int n2 = 4 - n_of_rank(b, outs) - nr_hold_b;
					int k2 = 1 - nr_hold_b;
					
					int nr_hold_c = n_of_rank(c, hold);				
					int n3 = 4 - n_of_rank(c, outs) - nr_hold_c;
					int k3 = 1 - nr_hold_c;
					
					if (k1 < 0) k1 = 0;
					if (k2 < 0) k2 = 0;
					if (k3 < 0) k3 = 0;
					
					if (k1 + k2 + k3 == n_draw)
					{
						long co = Prob.combinations_k(n1, k1) * Prob.combinations_k(n2, k2) * Prob.combinations_k(n3, k3);
						res += co;
					}
				}		
			}
		}		
		
		res /= Prob.factoriel(2); // (12, 2), n nested cycles, ? if there card in outs
		
		return res;
	}
	

	public long num_of_full_houses(int hold[], int outs[], int n_draw)
	{
		int res = 0;
		for (int a = 0; a < 13; a++)
		{
			for (int b = 0; b < 13; b++)
			{				
				if (b == a) continue;
				
				int nr_hold_a = n_of_rank(a, hold);				
				int n1 = 4 - n_of_rank(a, outs) - nr_hold_a;
				int k1 = 3 - nr_hold_a;
				
				
				int nr_hold_b = n_of_rank(b, hold);				
				int n2 = 4 - n_of_rank(b, outs) - nr_hold_b;
				int k2 = 2 - nr_hold_b;
				
				if (k1 < 0) k1 = 0;
				if (k2 < 0) k2 = 0;
				
				if (k1 + k2 == n_draw)
				{
					long co = Prob.combinations_k(n1, k1) * Prob.combinations_k(n2, k2);
					res += co;
				}
			}
		}		
		return res;
	}
	
	public long num_of_two_pairs(int hold[], int outs[], int n_draw)
	{
		int res = 0;
		for (int a = 0; a < 13; a++)
		{			
			for (int b = 0; b < 13; b++)
			{
				if (b == a) continue;
				
				for (int c = 0; c < 13; c++)
				{
					if (c == a || c == b) continue;
					
					int nr_hold_a = n_of_rank(a, hold);				
					int n1 = 4 - n_of_rank(a, outs) - nr_hold_a;
					int k1 = 2 - nr_hold_a;
					
					
					int nr_hold_b = n_of_rank(b, hold);				
					int n2 = 4 - n_of_rank(b, outs) - nr_hold_b;
					int k2 = 2 - nr_hold_b;
					
					int nr_hold_c = n_of_rank(c, hold);				
					int n3 = 4 - n_of_rank(c, outs) - nr_hold_c;
					int k3 = 1 - nr_hold_c;
					
					if (k1 < 0) k1 = 0;
					if (k2 < 0) k2 = 0;
					if (k3 < 0) k3 = 0;
					
					if (k1 + k2 + k3 == n_draw)
					{
						long co = Prob.combinations_k(n1, k1) * Prob.combinations_k(n2, k2) * Prob.combinations_k(n3, k3);
						res += co;
					}
				}		
			}
		}
		
		res /= Prob.factoriel(2);
		
		return res;
	}
	
	public long num_of_one_pairs(int hold[], int outs[], int n_draw, int min_high_paid)
	{
		int res = 0;
		//for (int a = 0; a < 13; a++)
		for (int a = 0; a < 13; a++)
		{	
			if (a < min_high_paid) continue; // HIGH PAIR only, 9 == J, 8 - ten
			
			for (int b = 0; b < 13; b++)
			{
				if (b == a) continue;
				
				for (int c = 0; c < 13; c++)
				{
					if (c == a || c == b) continue;
					
					for (int d = 0; d < 13; d++)
					{
						if (d == a || d == b || d == c) continue;
						
						int nr_hold_a = n_of_rank(a, hold);				
						int n1 = 4 - n_of_rank(a, outs) - nr_hold_a;
						int k1 = 2 - nr_hold_a;
						
						
						int nr_hold_b = n_of_rank(b, hold);				
						int n2 = 4 - n_of_rank(b, outs) - nr_hold_b;
						int k2 = 1 - nr_hold_b;
						
						int nr_hold_c = n_of_rank(c, hold);				
						int n3 = 4 - n_of_rank(c, outs) - nr_hold_c;
						int k3 = 1 - nr_hold_c;
						
						int nr_hold_d = n_of_rank(d, hold);				
						int n4 = 4 - n_of_rank(d, outs) - nr_hold_d;
						int k4 = 1 - nr_hold_d;
						
						if (k1 < 0) k1 = 0;
						if (k2 < 0) k2 = 0;
						if (k3 < 0) k3 = 0;
						if (k4 < 0) k4 = 0;
						
						if (k1 + k2 + k3 + k4 == n_draw)
						{
							long co = Prob.combinations_k(n1, k1) * Prob.combinations_k(n2, k2) * Prob.combinations_k(n3, k3) * Prob.combinations_k(n4, k4);
							res += co;
						}
					}
				}		
			}
		}		
		
		res /= Prob.factoriel(3);
		
		return res;
	}
	
	
	public long num_of_one_pairs_comb(int hold[], int outs[], int n_draw, int min_high_paid)
	{
		int res = 0;
		
		int a = 9;
		int b = 10;
		int c = 11;
		int d = 12;
		
		
		
		int nr_hold_a = n_of_rank(a, hold);				
		int n1 = 4 - n_of_rank(a, outs) - nr_hold_a;
		int k1 = 2 - nr_hold_a;
		
		
		int nr_hold_b = n_of_rank(b, hold);				
		int n2 = 4 - n_of_rank(b, outs) - nr_hold_b;
		int k2 = 2 - nr_hold_b;
		
		int nr_hold_c = n_of_rank(c, hold);				
		int n3 = 4 - n_of_rank(c, outs) - nr_hold_c;
		int k3 = 2 - nr_hold_c;
		
		int nr_hold_d = n_of_rank(d, hold);				
		int n4 = 4 - n_of_rank(d, outs) - nr_hold_d;
		int k4 = 2 - nr_hold_d;
		
		if (k1 < 0) k1 = 0;
		if (k2 < 0) k2 = 0;
		if (k3 < 0) k3 = 0;
		if (k4 < 0) k4 = 0;
		
		
		long co = Prob.combinations_k(n1, k1) * Prob.combinations_k(47 - n1, n_draw - k1) +  
				Prob.combinations_k(n2, k2)* Prob.combinations_k(47 - n2, n_draw - k2) +  
				+ Prob.combinations_k(n3, k3) * Prob.combinations_k(47 - n3, n_draw - k3) +  
				+ Prob.combinations_k(n4, k4) * Prob.combinations_k(47 - n4, n_draw - k4);
		
		//long co = Prob.combinations_k(n1, k1) * Prob.combinations_k(n2, k2) * Prob.combinations_k(n3, k3) * Prob.combinations_k(n4, k4);
		res += co;
		
		return res;
	}
	
	
	public long num_of_straight_flushes(int hold[], int outs[], int n_draw)
	{
		long res = 0;
		
		for (int a = 0; a < 4; a++)
		{			
			for (int i = 0; i < 9; i++)
			{
				int c1 = a * 13 + i + 0;
				int c2 = a * 13 + i + 1;
				int c3 = a * 13 + i + 2;
				int c4 = a * 13 + i + 3;
				int c5 = a * 13 + i + 4;
				
				int straight[] = {c1, c2, c3, c4, c5};
				
				if (posible_straght(straight, hold, outs, n_draw)) res++;
				
				if (c1 % 13 == 0) // A2345
				{
					c5 = a * 13 + i + 12;
					int straight_A2345[] = {c1, c2, c3, c4, c5};
					
					if (posible_straght(straight_A2345, hold, outs, n_draw)) res++;
				}
			}
		}
		
		return res;	
	}
	
	public boolean posible_straght(int straight[], int hold[], int outs[], int n_draw)
	{
		if (Utils.contains(outs, straight) == 0)
		{
			if (Utils.contains(hold, straight) + n_draw == 5)
			{
				return true;
			}					
		}
		return false;
	}
	
	public long num_of_straights(int hold[], int outs[], int n_draw)
	{
		int n = 4;
		int res = 0;
		for (int a = 0; a < n; a++)
		{			
			for (int b = 0; b < n; b++)
			{
				for (int c = 0; c < n; c++)
				{					
					for (int d = 0; d < n; d++)
					{					
						for (int e = 0; e < n; e++)
						{						
							for (int i = 0; i < 9; i++)
							{
								int c1 = a * 13 + i + 0;
								int c2 = b * 13 + i + 1;
								int c3 = c * 13 + i + 2;
								int c4 = d * 13 + i + 3;
								int c5 = e * 13 + i + 4;
								
								int straight[] = {c1, c2, c3, c4, c5};
								if (posible_straght(straight, hold, outs, n_draw))
								{
									res++;
								}
								
								if (c1 % 13 == 0) // A2345
								{
									c5 = e * 13 + i + 12;
									int straight_A2345[] = {c1, c2, c3, c4, c5};
									
									if (posible_straght(straight_A2345, hold, outs, n_draw)) res++;
								}
							}
						}
					}
				}		
			}
		}
		
		return res;	
	}
	
	public int n_of_rank(int i, int outs[])
	{
		int cnt = 0;
		for (int j = 0; j < outs.length; j++)
		{			
			int card = outs[j] % 13;
			if (i == card)
			{
				cnt++;
			}
		}
		return cnt;
	}
	
	public int n_of_suit(int i, int outs[])
	{
		int cnt = 0;
		for (int j = 0; j < outs.length; j++)
		{			
			int suit = outs[j] / 13;
			if (i == suit)
			{
				cnt++;
			}
		}
		return cnt;
	}
	
	Poker poker = Poker.createGame(Poker.TYPE_JACKS_OR_BETTER);
	
	public double Exp(long n, int draw, int card_left, int payout_type) // sum oaf all types in payout
	{		 
		double d = Prob.combinations_k(card_left, draw);
		
		double e = (n / d) * poker.getPayout(payout_type);
		
		return e;
	}
	
	
	public int getHoldCnt(boolean h[])
	{
		int cnt = 0;
		for (int i = 0; i < h.length; i++)
		{
			if (h[i]) cnt++;
		}		
		return cnt;
	}
	
	public int getDropCnt(boolean h[])
	{
		int cnt = 0;
		for (int i = 0; i < h.length; i++)
		{
			if (!h[i]) cnt++;
		}		
		return cnt;
	}
	
	public int[] getHold(int hand[], boolean h[], int len)
	{
		int j = 0;
		int hold[] = new int[len];
		for (int i = 0; i < hand.length; i++)
		{
			if (h[i])
			{
				hold[j++] = hand[i];
			}
		}		
		return hold;
	}
	
	public int[] getOUTS(int hand[], boolean h[], int len)
	{
		int j = 0;
		int outs[] = new int[len];
		for (int i = 0; i < hand.length; i++)
		{
			if (!h[i])
			{
				outs[j++] = hand[i];
			}
		}		
		return outs;
	}
	
	public static void main(String args[])
	{
		new Test_9_Evaluate();
	}


}
