package com.aza.vp.he;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Random;

import com.aza.vp.game.Poker;
import com.aza.vp.he.HoldEv.PayoutType;


public class Utils
{
	
	public static int getHoldCnt(boolean h[])
	{
		int cnt = 0;
		for (int i = 0; i < h.length; i++)
		{
			if (h[i]) cnt++;
		}		
		return cnt;
	}
	
	public static int getDropCnt(boolean h[])
	{
		int cnt = 0;
		for (int i = 0; i < h.length; i++)
		{
			if (!h[i]) cnt++;
		}		
		return cnt;
	}
	
	public static int[] getHold(int hand[], boolean h[], int len)
	{
		int j = 0;
		int hold[] = new int[len];
		for (int i = 0; i < hand.length; i++)
		{
			if (h[i])
			{
				hold[j++] = hand[i];
			}
		}		
		return hold;
	}
	
	public static int[] getOUTS(int hand[], boolean h[], int len)
	{
		int j = 0;
		int outs[] = new int[len];
		for (int i = 0; i < hand.length; i++)
		{
			if (!h[i])
			{
				outs[j++] = hand[i];
			}
		}		
		return outs;
	}
	
	public static boolean contains(int a[], int x)
	{
		for (int i = 0; i < a.length; i++)
		{
			if (a[i] == x) return true;			
		}
		return false;
	}
	
	public static int contains(int a[], int b[]) // unordered
	{
		int cnt = 0;
		
		for (int i = 0; i < a.length; i++)
		{
			for (int j = 0; j < b.length; j++)
			{
				if (a[i] == b[j]) cnt++;			
			}	
		}
		return cnt;
	}
	
	public static boolean contains_all(int a[], int b[]) // unordered
	{
		return contains(a, b) == b.length;
	}
	
	public static float clamp(float x, float y, float z)
	{
		z = z < x ? x : z;
		z = z > y ? y : z;		
		return z;
	}
	
	
	
	public static void shuffleArray(int[] a)
	{
		int n = a.length;
		Random random = new Random();
		random.nextInt();
		for (int i = 0; i < n; i++) {
			int change = i + random.nextInt(n - i);
			swap(a, i, change);
		}
	}

	private static void swap(int[] a, int i, int change) {
		int helper = a[i];
		a[i] = a[change];
		a[change] = helper;
	}
	
	static class HoldEvComp implements Comparator<HoldEv>
	{
		@Override
		public int compare(HoldEv v1, HoldEv v2)
		{
			if(v1.exp > v2.exp) return -1;
			if(v1.exp < v2.exp) return 1;
			return 0;
		}
	}
	
	
	public static void printHoldEv(HoldEv he[], Poker poker)
	{
		Arrays.sort(he, new HoldEvComp());
		
		for (int i = 0; i < he.length; i++)
		{
			System.out.println("----------------------------------------------------------------");
			Poker.print_hand(he[i].cards_held);
			
			HoldEv ev = he[i];
			
			System.out.println("n_draw: " + he[i].n_draw);
			System.out.println("exp v: " + String.format("%f", he[i].exp) + "\t\t\texp payout: " + he[i].payout);
			
			System.out.println("----------------------------------------------------------------");
			
			int total = 0;
			
			for (int j = 0; j < ev.payout_type.length; j++)
			{
				PayoutType type = ev.payout_type[j];
				System.out.println("\t type: " + poker.getHandString(type.type) + "\t\t\tcomb: " +  type.win_combinations + "\t\t\tprob: " + String.format("%f", type.prob) + "\t\t\texp: " + String.format("%f", type.exp) );
				
				total += type.win_combinations;
			}
			
			
			System.out.println("----------------------------------------------------------------tot comb: " + total);
		}
	}
	
	public static void printHoldEv(HoldEv he, Poker poker)
	{
			
			System.out.println("----------------------------------------------------------------");
						
			for (int j = 0; j < he.payout_type.length; j++)
			{
				PayoutType type = he.payout_type[j];
				System.out.println("\t type: " + poker.getHandString(type.type) + "\t\t\tcomb: " +  type.win_combinations + "\t\t\tprob: " + String.format("%f", type.prob) + "\t\t\texp: " + String.format("%f", type.exp) );
				
			}
	}

}
